---

image: samueldebruyn/debian-git:latest

stages:
  - style
  - test
  - build


clang_tidy:
    image: joethei/clang_tidy
    stage: style
    tags:
      - docker-ci
    script:
      - mkdir current
      - ls -d .[!.]* | grep -v current | xargs mv -t current
      - git clone https://gitlab-ci-token:${CI_JOB_TOKEN}@gitlab.repo.digitech.hs-emden-leer.de/link/projekte/ws19/vkvm-new/library.git
      - mkdir library/build
      - cd library/build
      - cmake ..
      - make
      - cd ../../current/.ci
      - sh clang-tidy.sh

make_test:
  stage: test
  tags:
    - docker-ci
  script:
    - apt-get update
    - apt-get install -y clang make cmake clang-tidy
    - mkdir current
    - ls | grep -v current | xargs mv -t current
    - git clone https://github.com/catchorg/Catch2.git
    - cd Catch2
    - cmake -Bbuild -H. -DBUILD_TESTING=OFF
    - cmake --build build/ --target install
    - cd ..
    - git clone https://gitlab-ci-token:${CI_JOB_TOKEN}@gitlab.repo.digitech.hs-emden-leer.de/link/projekte/ws19/vkvm-new/library.git
    - mkdir library/build
    - cd library/build
    - cmake ..
    - make
    - cd ../../current
    - mkdir build
    - cd build
    - cmake ..
    - make
    - make test

cmake_build:
  stage: build
  tags:
    - docker-ci
  script:
    - apt-get update
    - apt-get install -y clang make cmake clang-tidy
    - mkdir current
    - ls | grep -v current | xargs mv -t current
    - git clone https://github.com/catchorg/Catch2.git
    - cd Catch2
    - cmake -Bbuild -H. -DBUILD_TESTING=OFF
    - cmake --build build/ --target install
    - cd ..
    - git clone https://gitlab-ci-token:${CI_JOB_TOKEN}@gitlab.repo.digitech.hs-emden-leer.de/link/projekte/ws19/vkvm-new/library.git
    - mkdir library/build
    - cd library/build
    - cmake ..
    - make
    - cd ../../current
    - mkdir build
    - cd build
    - cmake ..
    - make
